﻿using Infragistics.Windows;
using Infragistics.Windows.Controls;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Globalization;
using System.Runtime.CompilerServices;

namespace LabelPresenterStyling
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = new ViewModel();
        }
    }

    public class ViewModel
    {
        static ViewModel()
        {
            SexList = new ObservableCollection<SexType>();

            SexList.Add(new SexType("MALE"));
            SexList.Add(new SexType("FEMALE"));
        }

        public ViewModel()
        {

            _dataList.Add(new DataItem(true, true, 200000, true, "Superman", true, 35, true, 15, "Lives in Smallville.", "MALE", true));

            _dataList.Add(new DataItem(true, false, 100000, false, "Non-Editable Man", false, 45, false, 5, "Lives in Portland.", "MALE", false));

            _dataList.Add(new DataItem(true, true, 40000, true, "Error Girl", true, 188, true, 570, "Lives in Tigard.", "FEMALE", true));

            _dataList.Add(new DataItem(true, false, 30000, false, "Non-Editable Error Girl", false, 276, false, 1001, "Lives in Hillsboro.", "FEMALE", false));
        }

        public static ObservableCollection<SexType> SexList { get; set; }

        ObservableCollection<DataItem> _dataList = new ObservableCollection<DataItem>();
        public ObservableCollection<DataItem> DataList { get { return _dataList; } set { _dataList = value; } }
    }

    public class DataItem : DependencyObject, IDataErrorInfo, INotifyPropertyChanged
    {
        public DataItem(bool? isApproved, bool canEditIsApproved, decimal salary, bool canEditSalary, string empName, bool canEditEmpName, int age, bool canEditAge, int yearsOfService, string generalComment, string sex, bool canEditSex)
        {
            IsApproved = isApproved;
            CanEditIsApproved = canEditIsApproved;
            Salary = salary;
            CanEditSalary = canEditSalary;
            EmpName = empName;
            CanEditEmpName = canEditEmpName;
            Age = age;
            CanEditAge = canEditAge;
            YearsOfService = yearsOfService;
            GeneralComment = generalComment;
            Sex = sex;
            CanEditSex = canEditSex;
        }

        public bool? IsApproved { get; set; }

        public bool CanEditIsApproved { get; set; }

        public decimal Salary { get; set; }

        public bool CanEditSalary { get; set; }

        public string EmpName { get; set; }

        public bool CanEditEmpName { get; set; }

        public int Age { get; set; }

        public bool CanEditAge { get; set; }

        public string Sex { get; set; }

        public bool CanEditSex { get; set; }

        public int YearsOfService { get; set; }

        public string GeneralComment { get; set; }

        public string Error
        {
            get
            {
                string returnStr = string.Empty;

                if (Salary < 75000)
                    returnStr += "Salary too small\n";
                if (EmpName.Contains("Girl"))
                    returnStr += "Possibly a female name???\n";
                if (Age > 100)
                    returnStr += "Too old\n";
                if (Sex != "MALE")
                    returnStr = "Not a male superhero";

                return returnStr;
            }
        }

        public string this[string columnName]
        {
            get
            {
                string returnStr = string.Empty;

                if (columnName == "Salary" && Salary < 75000)
                    returnStr = "Salary too small";
                else if (columnName == "EmpName" && EmpName.Contains("Girl"))
                    returnStr += "Possibly a female name???\n";
                else if (columnName == "Age" && Age > 100)
                    returnStr = "Too old";
                else if (columnName == "Sex" && Sex != "MALE")
                    returnStr = "Not a male superhero";

                return returnStr;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        // This method is called by the Set accessor of each property. 
        // The CallerMemberName attribute that is applied to the optional propertyName 
        // parameter causes the property name of the caller to be substituted as an argument. 
        private void NotifyPropertyChanged(String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class SexType
    {
        public SexType(string name)
        {
            SexStr = name;
        }

        public string SexStr { get; set; }
    }
}
